
	global origfov, origrendtimetype, origrendstart, origrendend, origrendnth, origrendfilenumberbase, origrendPickupframes, orig_layout, \
	orig_type, orig_cam, dwidth, wascancelled, stereocam_settings_rollout, stereoprogress_rollout

	global calculateRatio, changeRangesColor, toggleFrame, toggleRanges, render_sequence, render_eachframe, \
	restore_originalvalues, save_originalvalues, getframesequence, getZeros, rendPickupAsArray, delegate_render, \
	render_cam04, render_cam02, render_stereo, preview_last, render_preview, render_viewport_preview, \
	postrender_fn, process_images, setScreenPreset
	
	persistent global allStereoCameras
	
	global store_and_comp, stored_left_frames, stored_right_frames
	
	
	fn store_and_comp =
	(
		
		a = rendoutputfilename
		
		f = ((((callbacks.notificationParam())[13]) as integer)/TicksPerFrame) as string
		if rendtimetype > 1 then str = (getfilenamepath a)+(getfilenamefile a)+(getZeros (f))+(getfilenametype a)
			else str = (getfilenamepath a)+(getfilenamefile a)+(getfilenametype a)
		str = substitutestring str "\\" "/"	
		RightImg = copy str
		leftImg = substituteString (copy str) "right" "left"
		FilePath = substituteString (copy str) "right" "stereo"
		
		
		stereoimage = process_images (openBitMap leftImg) (getlastrenderedimage()) FilePath
		save stereoimage
		close stereoimage
		framecounter += 1
	)
	
	
	fn store_and_comp_vray =
	(
		
		a = rendoutputfilename
		
		f = ((((callbacks.notificationParam())[13]) as integer)/TicksPerFrame) as string
		if rendtimetype > 1 then str = (getfilenamepath a)+(getfilenamefile a)+(getZeros (f))+(getfilenametype a)
			else str = (getfilenamepath a)+(getfilenamefile a)+(getfilenametype a)
		str = substitutestring str "\\" "/"	
		FilePath = substituteString (copy str) "right" "stereo"
		
		VrayImage = getlastrenderedimage()
		leftimage = bitmap renderwidth renderheight
		pastebitmap VrayImage leftimage [0,0] [0,0] type:#paste
		rightimage = bitmap renderwidth renderheight
		pastebitmap VrayImage rightimage [renderwidth,0] [0,0] type:#paste
		stereoimage = (process_images leftImage rightImage Filepath)	
		save stereoimage
		close stereoimage
		framecounter += 1
	)
	
	fn remove_stereo_callbacks=
	(
		callbacks.removescripts #postRenderFrame id:#3dhippie 
		callbacks.removescripts #postRender id:#3dhippie 
	)

	
	fn RemoveCamera = -- clean up scene if camera was deleted
	(
		
		try 
		(
			if (callbacks.notificationParam()).modifiers[#stereocam_settings] != undefined  then-- it's a stereoCam
			(
				theCam = (callbacks.notificationParam())
				CamNodes = theCam.modifiers[#stereocam_settings].camera_nodes
				HelperNodes = theCam.modifiers[#stereocam_settings].helper_nodes
				
				for x in CamNodes do
					try delete (getnodebyname(x)) catch()
				for x in HelperNodes do
					try delete (getnodebyname(x)) catch()
				
				deleteItem allStereoCameras (findItem allStereoCameras theCam)
			)
					
		) catch( print (getCurrentException()) )
	
	)
	callbacks.removescripts #NodePreDelete id:#3dhippie 
	callbacks.addscript #NodePreDelete "RemoveCamera()" id:#3dhippie 
	
	fn RenameCamera = -- clean up scene if camera was deleted
	(
		
		try 
		(
			if (callbacks.notificationParam())[3].modifiers[#stereocam_settings] != undefined  then-- it's a stereoCam
			(
				oldname = (callbacks.notificationParam())[1]
				newname = (callbacks.notificationParam())[2]
				theCam = (callbacks.notificationParam())[3]
				print newname
				print oldname.count
					
				CamNodes = theCam.modifiers[#stereocam_settings].camera_nodes
				HelperNodes = theCam.modifiers[#stereocam_settings].helper_nodes
				
				for x = 1 to CamNodes.count do
				(
					str = copy ((getnodebyname(CamNodes[x])).name) 
					nstr = (replace str 1 oldname.count newname)
					(getnodebyname(CamNodes[x])).name = nstr
					theCam.modifiers[#stereocam_settings].stereoCam_Controls.camera_nodes[x] = nstr
				)
				for x = 1 to HelperNodes.count do
				(
					str = copy ((getnodebyname(HelperNodes[x])).name) 
					nstr = (replace str 1 oldname.count newname)
					(getnodebyname(HelperNodes[x])).name = nstr
					theCam.modifiers[#stereocam_settings].stereoCam_Controls.helper_nodes[x] = nstr
				)
				
			)
					
		) catch( print (getCurrentException()) )
	
	)
	callbacks.removescripts #nodeNameSet id:#3dhippie 
	callbacks.addscript #nodeNameSet "RenameCamera()" id:#3dhippie 

	
	fn updateAllControllers =
	(
		try 
		(
			for scam in allStereoCameras do
			(
				scam.modifiers[#stereocam_settings].bracketsize.controller.update()
				(getNodebyName(scam.modifiers[#stereocam_settings].helper_nodes[1])).position.controller.XPosition.controller.update
				(getNodebyName(scam.modifiers[#stereocam_settings].helper_nodes[1])).length.controller.update
				(getNodebyName(scam.modifiers[#stereocam_settings].helper_nodes[1])).width.controller.update
					
				(getNodebyName(scam.modifiers[#stereocam_settings].helper_nodes[2])).position.controller.XPosition.controller.update
				(getNodebyName(scam.modifiers[#stereocam_settings].helper_nodes[2])).length.controller.update
				(getNodebyName(scam.modifiers[#stereocam_settings].helper_nodes[2])).width.controller.update	
					
			)
		)
		catch()
	)
	
	callbacks.removescripts #renderParamsChanged id:#3dhippie 
	callbacks.addScript #renderParamsChanged "updateallcontrollers()" id:#3dhippie
	
	fn postrender_fn = 
	(
		print ((callbacks.notificationParam())[13])

	)



	

fn process_images leftImg rightImg filepath fromviewport:false =
(
	
		
	left = copy leftImg
	right = copy rightImg
	crop_amount = 0
	
	
	p = (left.width*left.height)/100
	
	if filepath != undefined then newImage = bitmap right.width right.height filename:filepath else newImage = bitmap right.width right.height 
	if $.modifiers[#stereocam_settings].previewtype < 6 then pastebitmap left newImage [0,0] [0,0] type:#paste
	
	local gamma_correct,anaglyph_fn,anaglyph_corrected_fast_fn, anaglyph_corrected_fn, anaglyph_monochrome_fn, polarized_fn
	
	if $.modifiers[#stereocam_settings].previewtype < 6 then 
	(
		rollout stereoprogress_rollout "Processing two Images"
		(
			progressBar prg_process value:10 color:blue
		)
			
		createDialog stereoprogress_rollout 400 60
	)
	
	if fromviewport then --calculate offset
	(
		--fwidth = (left.width*(($.modifiers[#stereocam_settings].camdist/(2*$.modifiers[#stereocam_settings].focus*tan($.modifiers[#stereocam_settings].fov/2)))+1))
		crop_amount = 27	
	)
	
	fn gamma_correct cl_channel gamma:1.5 =	
	(
		res = ( 255 * (pow  cl_channel  (1/gamma) ))/( pow 255 ( 1 / gamma ) )
		res
	)
		
	fn anaglyph_fn color1 pixel1 color2 pixel2 = 
	(
		if (mod pixel1.x renderwidth) == 0 do (stereoprogress_rollout.prg_process.value = pixel1.y/(renderheight/100.0))
		res = color1 --the result will contain the Green and Blue of b2
		res.r = color2.r --but the R from b1
		res 
	)

	fn anaglyph_corrected_fast_fn color1 pixel1 color2 pixel2 = -- a much faster but less beautiful version of the optimized anaglyph algorithm
	(
		if (mod pixel1.x renderwidth) == 0 do (stereoprogress_rollout.prg_process.value = pixel1.y/(renderheight/100.0))
		res = color1
		res.r = (color2.g*0.7)+(color2.b*0.3)
		res
	)

	fn anaglyph_corrected_fn color1 pixel1 color2 pixel2 =  -- optimized anaglyph using the algorithm from 3dtv. Thanks to Peter Wimmer.
	(
		--stereoprogress_rollout.prg_process.value = stereoprogress_rollout.prg_process.value+p
		if (mod pixel1.x renderwidth) == 0 do (stereoprogress_rollout.prg_process.value = pixel1.y/(renderheight/100.0))
		f1 = 0.45
		f2 = 0.25
		g = 1.5
		res = color1
		
		g1_ = color2.g + (f1 * amax #(0 ,(color2.r-color2.g)))
		b1_ = color2.b + (f2 * amax #(0 ,(color2.r-color2.b)))
			
		g2_ = color1.g + (f1 * amax #(0 ,(color1.r-color1.g)))
		b2_ = color1.b + (f2 * amax #(0 ,(color1.r-color1.b)))
		
		ra_ = (191 * g1_ + 64 * b1_) / 255

		res = (color ((255 * (pow  ra_  (1/1.5) ))/( pow 255 ( 1 / 1.5 ) ))  g2_ b2_ color1.a)
		
		--res.g = g2_
		--res.b = b2_
			
		--res	
		
		
	)

	fn anaglyph_monochrome_fn color1 pixel1 color2 pixel2 = 
	(
		if (mod pixel1.x renderwidth) == 0 do (stereoprogress_rollout.prg_process.value = pixel1.y/(renderheight/100.0))
		res = color2 --the result will contain the Green and Blue of b2
		res.r = (color2.r*0.299)+(color2.g*0.587)+(color2.b*0.114)  
		res.g = (color1.r*0.299)+(color1.g*0.587)+(color1.b*0.114) 
		res.b = res.g
		res
	)

	fn polarized_fn color1 pixel1 color2 pixel2 = 
	(
		if (mod pixel1.x renderwidth) == 0 do (stereoprogress_rollout.prg_process.value = pixel1.y/(renderheight/100.0))
		if ((mod pixel1.y 2) == 0) then (res = color1) else (res = color2)
		res
	)	
	
	--fn getmax val1 val2 = ( if val1 >= val2 then (val1) else (val2))
		
	--stereoprogress_rollout.prg_process.value = 20
		
	--#("anaglyph (red/cyan)", "monochrome anaglyph","optimized anaglyph (fast)","optimized anaglyph (best)","polarized (interlaced)", "side by side")
	
		
	
	case $.modifiers[#stereocam_settings].previewtype of
	(
		1:	
		(	
			pastebitmap right newImage [0,0] [0,0] type:#function function:anaglyph_fn--anaglyph with no correction
			stereoprogress_rollout.prg_process.value = 100
			destroydialog stereoprogress_rollout
			
		)
		2:	
		(
			pastebitmap right newImage [0,0] [0,0] type:#function function:anaglyph_monochrome_fn --anaglyph with correction
			stereoprogress_rollout.prg_process.value = 100
			destroydialog stereoprogress_rollout
			
		)
		3:	
		( 
			pastebitmap right newImage [0,0] [0,0] type:#function function:anaglyph_corrected_fast_fn --polarized
			stereoprogress_rollout.prg_process.value = 100
			destroydialog stereoprogress_rollout
			
		)
		4:	
		(
			pastebitmap right newImage [0,0] [0,0] type:#function function:anaglyph_corrected_fn --polarized
			stereoprogress_rollout.prg_process.value = 100
			destroydialog stereoprogress_rollout
			
			
		)
		5:
		(
			
			pastebitmap right newImage [0,0] [0,0] type:#function function:polarized_fn --monochrome anaglyph
			stereoprogress_rollout.prg_process.value = 100
			destroydialog stereoprogress_rollout
			
		)
		6:	
		(
			if filepath != undefined then newImage = bitmap (right.width*2) right.height filename:filepath else newImage = bitmap (right.width*2) right.height
			pastebitmap left newImage [0,0] [0,0] type:#paste
			pastebitmap right newImage [0,0] [right.width,0] type:#paste
			--stereoprogress_rollout.prg_process.value = 100
			--destroydialog stereoprogress_rollout
			
		)
		7:	
		(
			if filepath != undefined then newImage = bitmap (right.width*2) right.height filename:filepath else newImage = bitmap (right.width*2) right.height
			pastebitmap left newImage [0,0] [right.width,0] type:#paste
			pastebitmap right newImage [0,0] [0,0] type:#paste
			--stereoprogress_rollout.prg_process.value = 100
			--destroydialog stereoprogress_rollout
			
		)
		
		
		
	)
	
	close left
	close right
	close newimage
	return newImage
	
	
	
)

fn render_viewport_preview thecam=
(
	/*
	viewport.activeViewport = 2
	local leftImage = gw.getviewportDib()
	viewport.activeViewport = 4
	local rightImage = gw.getviewportDib()
	*/
	save_originalvalues() 
	/*maximized = false
	if viewport.numviews > 1 do 
	(
		max tool maximize
		maximized = true
	)*/
		
	shownear = (getNodebyName(thecam.helper_nodes[1])).ishidden
	showscreen = (getNodebyName(thecam.helper_nodes[2])).ishidden
	showfar = (getNodebyName(thecam.helper_nodes[3])).ishidden
	showVolume = (getNodebyName(thecam.helper_nodes[9])).ishidden
	showlookat = (getNodebyName(thecam.helper_nodes[8])).ishidden
	showcam1 = (getNodebyName(thecam.camera_nodes[1])).ishidden
	showcam2 = (getNodebyName(thecam.camera_nodes[2])).ishidden
	showcam3 = (getNodebyName(thecam.camera_nodes[3])).ishidden	
	
		
	(getNodebyName(thecam.helper_nodes[1])).ishidden = true
	(getNodebyName(thecam.helper_nodes[2])).ishidden = true
	(getNodebyName(thecam.helper_nodes[3])).ishidden = true
	(getNodebyName(thecam.helper_nodes[9])).ishidden = true
	(getNodebyName(thecam.helper_nodes[8])).ishidden = true
	(getNodebyName(thecam.camera_nodes[1])).ishidden = true
	(getNodebyName(thecam.camera_nodes[2])).ishidden = true
	(getNodebyName(thecam.camera_nodes[3])).ishidden = true	
	
	
	
	viewport.setcamera (getNodebyName(thecam.camera_nodes[1]))
	redrawviews()
	local leftImage = gw.getviewportDib()
	viewport.setcamera (getNodebyName(thecam.camera_nodes[3]))
	redrawviews()
	local rightImage = gw.getviewportDib()
	
	global stereoImage = (process_images leftImage rightImage undefined)
	display stereoImage
		
	(getNodebyName(thecam.helper_nodes[1])).ishidden = shownear
	(getNodebyName(thecam.helper_nodes[2])).ishidden = showscreen
	(getNodebyName(thecam.helper_nodes[3])).ishidden = showfar
	(getNodebyName(thecam.helper_nodes[9])).ishidden = showVolume
	(getNodebyName(thecam.helper_nodes[8])).ishidden = showlookat	
	(getNodebyName(thecam.camera_nodes[1])).ishidden = showcam1
	(getNodebyName(thecam.camera_nodes[2])).ishidden = showcam2
	(getNodebyName(thecam.camera_nodes[3])).ishidden = showcam3
	
	--if maximized do max tool maximize
	
		
	restore_originalvalues restoreviews:true
)

fn render_preview thecam =
(
	print thecam
	
		if classof (getNodebyName(thecam.camera_nodes[2])) != Vrayphysicalcamera and thecam.useVray then 
			if querybox ("The Vray Stereoscopic Plugin works best in combination with vray physical cameras. The focus will be set at a wrong distance with standard cameras. Do you want to disable the plugin?") == true
			then thecam.useVray = false else thecam.useVray = true

		renderscenedialog.close()
			
		-- save original settings
		
		
		orig_rendtimeType = rendtimetype
		orig_savefile = rendSaveFile 
		stored_left_frames = #()
		stored_right_frames = #()	
		
		rendTimeType  = 1
		rendSaveFile  = false
			
		-- do the rendering
		callbacks.removescripts #postRenderFrame id:#3dhippie 

		if thecam.useVray then
		(
			if renderers.current.output_on then messagebox "the chosen output type has no effect if vray frame buffer is active" 
			thecam.vrayplugin.enabled = true
			thecam.vrayplugin.eye_distance.controller = thecam.camdist.controller
			thecam.vrayplugin.focus_method = 2
			thecam.vrayplugin.view = 0
			thecam.vrayplugin.adjust_resolution = true
			
			save_originalvalues()
			viewport.setCamera (getNodebyName(thecam.camera_nodes[2])) --center camera
			max quick render
			restore_originalvalues restoreviews:true

			if renderers.current.output_on == false then
			(
				VrayImage = getlastrenderedimage()
				global leftimage = bitmap	renderwidth renderheight
				pastebitmap VrayImage leftimage [0,0] [0,0] type:#paste
				global rightimage = bitmap renderwidth renderheight
				pastebitmap VrayImage rightimage [renderwidth,0] [0,0] type:#paste
				global stereoimage = (process_images leftImage rightImage undefined)
				display stereoimage	
			)		
			
		)
		else
		(
			startrender = false
			if isproperty renderers.current "output_on" then 
				if renderers.current.output_on then messagebox "Please either turn off the vray frame-buffer or use the stereoscopic plugin. The vray vfb is currently not supported for stereo previews"
				else startrender = true
			else startrender = true
			
			if startrender then
			(				
				try (thecam.vrayplugin.enabled = false)catch()
				global leftImage = render_cam02 thecam
				global framecounter = 1
				global rightImage = render_cam04 thecam
				global stereoImage = (process_images leftImage rightImage undefined)
				display stereoImage
			)		
		)
		
		--restore old settings
		rendTimeType  = orig_rendtimeType
		rendSaveFile  = orig_savefile
		
	
)		

fn preview_last =
(
	if (rightImage != undefined) and (leftimage != undefined) then
	(
		if (rightimage.width == leftimage.width) and (rightimage.height == leftimage.height) then
		(
			start = timeStamp()
			global stereoImage = (process_images leftImage rightImage undefined)
			display stereoImage
			end = timeStamp()
			format "processing took % seconds\n" ((end - start) / 1000.0)
		)
	)
)

fn render_stereo thecam =
(
	stored_left_frames = #()
	stored_right_frames = #()	
	callbacks.removescripts #postRenderFrame id:#3dhippie 
	if thecam.useVray and thecam.vrayplugin != undefined then
	(
		renderscenedialog.close()
		save_originalvalues()
		renderwidth = renderwidth*2
		--global stereoimage =
		--if renderers.current.output_on then messagebox "you cannot comp each frame when vray frame buffer is on" 
		thecam.vrayplugin.enabled = true
		thecam.vrayplugin.eye_distance.controller = thecam.camdist.controller
		thecam.vrayplugin.focus_method = 2
		thecam.vrayplugin.view = 0
		thecam.vrayplugin.adjust_resolution =true
		
		
		viewport.setCamera (getNodebyName(thecam.camera_nodes[2])) --center camera
		--callbacks.addscript #postRenderFrame "store_and_comp_vray()" id:#3dhippie 
		local a = rendoutputfilename
		local FilePath = (getfilenamepath a)+"stereo_"+(thecam.name)+"_"+(getfilenamefile a)+"_"+(getfilenametype a) 
		rendoutputfilename = FilePath	
			
		global framecounter = 1		
		max quick render
		restore_originalvalues restoreviews:true
		callbacks.removescripts #postRenderFrame id:#3dhippie 
		rendoutputfilename = a
		
		
	)
	else --no vray plugin in use
	if ((global leftImage = render_cam02 thecam) != undefined) do 
	(
		if thecam.compframes then
		(
			callbacks.removescripts #postRenderFrame id:#3dhippie 
			callbacks.addscript #postRenderFrame "store_and_comp()" id:#3dhippie 
			global framecounter = 1
		)
		global rightImage = render_cam04 thecam
		callbacks.removescripts #postRenderFrame id:#3dhippie 
	)
)

fn render_cam02 thecam= 
(
	if thecam.usevray and thecam.vrayplugin != undefined then
	(
		thecam.vrayplugin.enabled = true
		thecam.vrayplugin.eye_distance.controller = thecam.camdist.controller
		thecam.vrayplugin.focus_method = 2
		thecam.vrayplugin.view = 1
		thecam.vrayplugin.adjust_resolution =true
		
		centercam = getNodebyName(thecam.camera_nodes[2])
		global leftImage = delegate_render (centercam) -1
		
	)
	else
	(
		leftcam = getNodebyName(thecam.camera_nodes[1])
		if classof leftcam == VrayPhysicalCamera then leftcam.side = 1 --camera is left camera
		global leftImage = delegate_render (leftcam) -1 
		if classof leftcam == VrayPhysicalCamera then leftcam.side = 2 --camera is center camera
		return leftImage
	)
) -- left render

fn render_cam04 thecam= 
(
	if thecam.usevray and thecam.vrayplugin != undefined then
	(
		thecam.vrayplugin.enabled = true
		thecam.vrayplugin.eye_distance.controller = thecam.camdist.controller
		thecam.vrayplugin.focus_method = 2
		thecam.vrayplugin.view = 2
		thecam.vrayplugin.adjust_resolution =true
		
		centercam = getNodebyName(thecam.camera_nodes[2])
		global leftImage = delegate_render (centercam) 1
		
	)
	else
	(
		rightcam = getNodebyName(thecam.camera_nodes[3])
		if classof rightcam == VrayPhysicalCamera then rightcam.side = 3 -- tell it to be a right camera
		global rightImage = delegate_render (getNodebyName(thecam.camera_nodes[3])) 1 
		if classof rightcam == VrayPhysicalCamera then rightcam.side = 2 -- tell it to be a center camera	
		return rightImage	
	)
) --right render

fn delegate_render theCam side=  -- delegates the render function
(
	myImage = undefined
	
	start = timeStamp()
	myImage = render_sequence theCam side
	end = timeStamp()
	format "rendering took % seconds\n" ((end - start) / 1000.0)
	
	format "quick render % \n" $.modifiers[#stereocam_settings].scriptrender
	
	
	if myImage == undefined do myImage = getLastRenderedImage()
	return myImage
)

fn rendPickupAsArray =
(
	theStr="#{"+rendpickupframes +"}"
	for i = theStr.count to 1 by -1 where theStr[i] == "-" do 
		theStr=replace theStr i 1 ".."
	(execute theStr) as array
)

fn getZeros theNum = (substring "0000" 1 (4-(theStr = theNum as string).count) + theStr )

fn getframesequence =  --puts all frames defined inside the renderscenedialog into a single array. 
(
	local framesequence = #()
	
	case rendTimeType of
	(
		2: for i = ((animationrange.start as integer)/TicksPerFrame) to ((animationrange.end as integer)/TicksPerFrame) by rendNThFrame do append framesequence i 
		3: for i = rendstart to rendend by rendNThFrame do append framesequence i
		4: framesequence = rendPickupAsArray()
	)
		
	return framesequence
)

fn save_originalvalues =
(
	actionMan.executeAction 0 "40227"
	
	--origfov = $.modifiers[#stereocam_settings].fov
	origrendtimetype = rendtimetype
	origrendstart = rendstart
	origrendend = rendend
	origrendnth = rendNthframe
	origrendfilenumberbase = rendFileNumberBase
	origrendPickupframes = rendPickupframes
	dwidth = renderwidth
	
	orig_layout = viewport.getlayout()
	orig_type = viewport.getType()
	orig_cam = viewport.getCamera()
)

fn restore_originalvalues restoreviews:false =
(
	--$.modifiers[#stereocam_settings].fov = origfov
	rendtimetype = origrendtimetype
	rendstart = origrendstart
	rendend = origrendend
	rendNthframe = origrendnth
	rendFileNumberBase = origrendfilenumberbase
	rendPickupframes = origrendPickupframes
	renderwidth = dwidth
	
	if restoreviews then
	(
		viewport.setlayout orig_layout
		if orig_type != #view_camera then viewport.settype orig_type
		if orig_cam != undefined do viewport.setcamera orig_cam
	)
	actionMan.executeAction 0 "40228"
)



-- RENDERS A SEQUENCE
-- starts only one render with for a predefined framerange
-- faster, but doesn't take changes of th FOV or Camdist into accout.
	
fn render_sequence theCamera side= -- side can be -1 = left or 1 = right
(
	myImage = undefined
	renderscenedialog.close()
	save_originalvalues() 
	local a = rendoutputfilename
	if (side == -1) then --side = -1  --> left side 
		( local FilePath = (getfilenamepath a)+"left_"+($.name)+"_"+(getfilenamefile a)+"_"+(getfilenametype a) )
	else if (side == 1) then --side = -1  --> right side
		( local FilePath = (getfilenamepath a)+"right_"+($.name)+"_"+(getfilenamefile a)+"_"+(getfilenametype a) )
	
	if not $.modifiers[#stereocam_settings].scriptrender then
	(
		rendoutputfilename = FilePath
		viewport.setCamera theCamera
		max quick render
	) 
	else
	(
		rendoutputfilename = FilePath
		case rendTimeType of
		(
			1:	myImage = render camera:theCamera Outputfile:FilePath quiet:false frame:#current  --gamma:2.2
			2: myImage = render camera:theCamera Outputfile:FilePath quiet:false framerange:#active nthframe:rendNThFrame progressbar:true--gamma:2.2
			3: myImage = render camera:theCamera Outputfile:FilePath quiet:false fromframe:rendstart toframe:rendend nthframe:rendNThFrame progressbar:true--gamma:2.2
			4: messagebox "you can not use the frame features with quick render" 
		)
	)
	restore_originalvalues restoreviews:true
	rendoutputfilename = a
		
	return myImage
)	
	

	fn RotatePivotOnly obj rotation = 
	( 
		local rotValInv=inverse (rotation as quat)
		animate off in coordsys local obj.rotation*=RotValInv
		obj.objectoffsetrot*=RotValInv
		obj.objectoffsetpos*=RotValInv

	)
	
	fn setScreenPreset sel =
	(
		if sel == 2 then  --17" desktop screen screen 
		(
			$.modifiers[#stereocam_settings].screenWidth = 340 -- 34 cm 
			$.modifiers[#stereocam_settings].screenResolution = 1280  --horizontal screen resolution
			$.modifiers[#stereocam_settings].viewDist = 1000 -- 1m sitting distance
			$.modifiers[#stereocam_settings].ratio = (((340 as float)/(1280 as float)) as string)
			
		)		
		
		if sel == 6 then
		(
			$.modifiers[#stereocam_settings].screenWidth = 850 -- 34 cm 
			$.modifiers[#stereocam_settings].screenResolution = 1280  --horizontal screen resolution
			$.modifiers[#stereocam_settings].viewDist = 2500 -- 1m sitting distance
			$.modifiers[#stereocam_settings].ratio = (((850 as float)/(1280 as float)) as string)
		)	
		if sel == 4 then --Zalman Monitor
		(
			$.modifiers[#stereocam_settings].screenWidth = 475 -- 34 cm 
			$.modifiers[#stereocam_settings].screenResolution = 1650  --horizontal screen resolution
			$.modifiers[#stereocam_settings].viewDist = 1950 -- 1m sitting distance
			$.modifiers[#stereocam_settings].ratio = (((850 as float)/(1280 as float)) as string)
		)	
		-- other presets here:	
	)		
	
	